"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.declarationPiral = exports.declarationPiralDefaults = void 0;
const path_1 = require("path");
const common_1 = require("../common");
const types_1 = require("../types");
exports.declarationPiralDefaults = {
    entry: './',
    target: './dist',
    forceOverwrite: common_1.ForceOverwrite.yes,
    logLevel: types_1.LogLevels.info,
};
async function declarationPiral(baseDir = process.cwd(), options = {}) {
    const { entry = exports.declarationPiralDefaults.entry, target = exports.declarationPiralDefaults.target, forceOverwrite = exports.declarationPiralDefaults.forceOverwrite, logLevel = exports.declarationPiralDefaults.logLevel, } = options;
    const fullBase = (0, path_1.resolve)(process.cwd(), baseDir);
    (0, common_1.setLogLevel)(logLevel);
    if (await (0, common_1.createPiralDeclaration)(fullBase, entry, target, forceOverwrite, logLevel)) {
        (0, common_1.logDone)(`Declaration created successfully in "${target}"!`);
    }
}
exports.declarationPiral = declarationPiral;
//# sourceMappingURL=declaration-piral.js.map