"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.packPilet = exports.packPiletDefaults = void 0;
const path_1 = require("path");
const common_1 = require("../common");
const types_1 = require("../types");
exports.packPiletDefaults = {
    source: '.',
    target: '.',
    logLevel: types_1.LogLevels.info,
};
async function packPilet(baseDir = process.cwd(), options = {}) {
    const { source = exports.packPiletDefaults.source, target = exports.packPiletDefaults.target, logLevel = exports.packPiletDefaults.logLevel, } = options;
    const fullBase = (0, path_1.resolve)(process.cwd(), baseDir);
    (0, common_1.setLogLevel)(logLevel);
    (0, common_1.progress)('Reading configuration ...');
    await (0, common_1.createPiletPackage)(fullBase, source, target);
    (0, common_1.logDone)(`Pilet packed successfully!`);
}
exports.packPilet = packPilet;
//# sourceMappingURL=pack-pilet.js.map