"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MemoryStream = void 0;
const stream_1 = require("stream");
class MemoryStream extends stream_1.Writable {
    constructor() {
        super(...arguments);
        this._buffers = [];
    }
    _write(chunk, enc, cb) {
        const buffer = Buffer.isBuffer(chunk) ? chunk : new Buffer(chunk, enc);
        this._buffers.push(buffer);
        cb();
    }
    get value() {
        return Buffer.concat(this._buffers).toString('utf8').replace(/\s+$/, '');
    }
}
exports.MemoryStream = MemoryStream;
//# sourceMappingURL=MemoryStream.js.map