"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.openBrowser = exports.openBrowserAt = void 0;
const log_1 = require("./log");
const config_1 = require("./config");
const external_1 = require("../external");
async function openBrowserAt(address) {
    try {
        await (0, external_1.open)(address, undefined);
    }
    catch (err) {
        (0, log_1.log)('failedToOpenBrowser_0170', err);
    }
}
exports.openBrowserAt = openBrowserAt;
async function openBrowser(shouldOpen, port, path, https) {
    if (shouldOpen) {
        const scheme = https ? 'https' : 'http';
        const address = `${scheme}://${config_1.config.host}:${port}${path}`;
        await openBrowserAt(address);
    }
}
exports.openBrowser = openBrowser;
//# sourceMappingURL=browser.js.map