/// <reference types="node" />
/// <reference types="node" />
import { Agent } from 'https';
import { FormData } from '../external';
import { PublishScheme } from '../types';
export declare function getAxiosOptions(url: string): {
    headers: {
        [x: string]: string;
    };
    auth?: undefined;
} | {
    auth: {
        username: string;
        password: string;
    };
    headers?: undefined;
} | {
    headers?: undefined;
    auth?: undefined;
};
export declare function getCertificate(cert?: string): Promise<Buffer>;
export declare function getAuthorizationHeaders(scheme: PublishScheme, key: string): {
    authorization: string;
} | {
    authorization?: undefined;
};
export declare function downloadFile(target: string, ca?: Buffer): Promise<Array<string>>;
export type FormDataObj = Record<string, string | number | boolean | [Buffer, string]>;
export declare function createAxiosForm(formData: FormDataObj): FormData;
export declare function handleAxiosError(error: any, interactive: boolean, httpsAgent: Agent, refetch: (mode: PublishScheme, key: string) => Promise<any>, onfail?: (status: number, statusText: string, response: string) => any): any;
export interface PostFormResult {
    status: number;
    success: boolean;
    response?: object;
}
export declare function postForm(target: string, scheme: PublishScheme, key: string, formData: FormDataObj, customHeaders?: Record<string, string>, ca?: Buffer, interactive?: boolean): Promise<PostFormResult>;
export declare function postFile(target: string, scheme: PublishScheme, key: string, file: Buffer, customFields?: Record<string, string>, customHeaders?: Record<string, string>, ca?: Buffer, interactive?: boolean): Promise<PostFormResult>;
