"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.concurrentWorkers = void 0;
async function concurrentWorkers(items, concurrency, worker) {
    const maxItems = items.length;
    const results = new Array(maxItems);
    let offset = 0;
    await Promise.all(items.slice(0, concurrency).map(async () => {
        while (offset < maxItems) {
            const i = offset++;
            const item = items[i];
            results[i] = await worker(item, i);
        }
    }));
    return results;
}
exports.concurrentWorkers = concurrentWorkers;
//# sourceMappingURL=parallel.js.map