"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.installPatch = exports.getPatch = void 0;
const patchMap = {};
function getPatch(packageName) {
    return patchMap[packageName];
}
exports.getPatch = getPatch;
function installPatch(packageName, patch) {
    if (packageName in patchMap) {
        const newPatch = patch;
        const oldPatch = patchMap[packageName];
        patch = (rootDir) => oldPatch(rootDir).then(() => newPatch(rootDir));
    }
    patchMap[packageName] = patch;
}
exports.installPatch = installPatch;
//# sourceMappingURL=patches.js.map