"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.configurePlatform = void 0;
const log_1 = require("./log");
function configurePlatform(target = {}) {
    const { platform = 'web', ...options } = target;
    if (platform === 'web') {
        const { setup } = require('../platforms/web');
        return setup(options);
    }
    else if (platform === 'node') {
        const { setup } = require('../platforms/node');
        return setup(options);
    }
    return (0, log_1.fail)('platformNotSupported_0190', platform);
}
exports.configurePlatform = configurePlatform;
//# sourceMappingURL=platform.js.map