"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getFreePort = exports.getAvailablePort = void 0;
const log_1 = require("./log");
const external_1 = require("../external");
async function getAvailablePort(defaultPort) {
    const selectedPort = await getFreePort(defaultPort);
    if (selectedPort !== defaultPort) {
        (0, log_1.log)('portNotFree_0047', selectedPort, defaultPort);
    }
    return selectedPort;
}
exports.getAvailablePort = getAvailablePort;
async function getFreePort(preferred) {
    (0, log_1.log)('generalDebug_0003', `Looking for a free port. Preferred port: ${preferred}`);
    const port = await (0, external_1.getPort)(preferred && { port: preferred });
    (0, log_1.log)('generalDebug_0003', `Found port ${port} free for usage.`);
    return port;
}
exports.getFreePort = getFreePort;
//# sourceMappingURL=port.js.map