import * as lerna from './lerna';
import * as npm from './npm';
import * as pnp from './pnp';
import * as pnpm from './pnpm';
import * as rush from './rush';
import * as yarn from './yarn';
import * as bun from './bun';
export declare const clients: {
    lerna: typeof lerna;
    npm: typeof npm;
    pnp: typeof pnp;
    pnpm: typeof pnpm;
    rush: typeof rush;
    yarn: typeof yarn;
    bun: typeof bun;
};
type ClientName = keyof typeof clients;
export declare function isWrapperClient(client: ClientName): boolean;
export declare function detectClients(root: string): Promise<{
    client: "npm" | "yarn" | "pnp" | "pnpm" | "lerna" | "rush" | "bun";
    result: boolean;
}[]>;
export {};
