"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getPiletRules = exports.addPiletRule = exports.getPiralRules = exports.addPiralRule = void 0;
const fs_1 = require("fs");
const common_1 = require("../common");
const piralRules = [];
const piletRules = [];
function getRules(target) {
    const prefix = `${target}-`;
    return new Promise((resolve, reject) => {
        (0, fs_1.readdir)(__dirname, (err, files) => {
            if (err) {
                reject(err);
            }
            else {
                resolve(files
                    .filter((name) => name.startsWith(prefix) && name.endsWith('.js'))
                    .map((fileName) => {
                    (0, common_1.log)('generalDebug_0003', `Including module "${fileName}" ...`);
                    const run = require(`./${fileName}`).default;
                    const name = fileName.substring(prefix.length).replace(/\.js$/, '');
                    (0, common_1.log)('generalDebug_0003', `Included rule with name: "${name}".`);
                    return {
                        run,
                        name,
                    };
                }));
            }
        });
    });
}
function addPiralRule(rule) {
    piralRules.push(rule);
}
exports.addPiralRule = addPiralRule;
async function getPiralRules() {
    (0, common_1.log)('generalDebug_0003', 'Getting Piral validation rules ...');
    const rules = await getRules('piral');
    (0, common_1.log)('generalDebug_0003', `Found ${rules.length} rules.`);
    return [...rules, ...piralRules];
}
exports.getPiralRules = getPiralRules;
function addPiletRule(rule) {
    piletRules.push(rule);
}
exports.addPiletRule = addPiletRule;
async function getPiletRules() {
    (0, common_1.log)('generalDebug_0003', 'Getting pilet validation rules ...');
    const rules = await getRules('pilet');
    (0, common_1.log)('generalDebug_0003', `Found ${rules.length} rules.`);
    return [...rules, ...piletRules];
}
exports.getPiletRules = getPiletRules;
//# sourceMappingURL=index.js.map