import { PiletRuleContext } from '../types';
export type Options = number;
/**
 * Checks if a pilet might cause a CSS conflict. A score of 100 means that
 * there is the least chance of a CSS conflict, while a score of 0 means that
 * a CSS conflict is most likely.
 *
 * Negative values yield a warning if the CSS score is below the given number.
 *
 * Positive values yield an error if the CSS score is below the given number.
 *
 * A value of 0 turns this validation off.
 *
 * By default, a pilet's stylesheet having a CSS score of below 50 will result in a warning.
 */
export default function (context: PiletRuleContext, options?: Options): Promise<void>;
